/* CONVERT v1.0 (Hitech .AS-file to TASM-format converter)
 * Dape/Istar 1997 (mkivela@norssi.oulu.fi)
 */

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dos.h>

char reloc_names[1600][32];
int reloc_lines[1600];
int verbose = 0;

/* Remove unneeded lines, convert some lines to a format supported by TASM */
int convert_low_level(char* inn, char* outn, char* title) {
  FILE *in,*out;
  char str[256];
  char c;
  int i;
  if((in = fopen(inn,"rt"))==NULL) {
    printf("Couldn't open file (%s)\n",inn);
    return 1;
    }
  if((out = fopen(outn,"wt"))==NULL) {
    printf("Couldn't open file (%s)\n",outn);
    return 1;
    }
  int quit = 0;
  fprintf(out,".org 0\n");
  fprintf(out,".db \"%s\",0\n",title);
  fprintf(out," jp _main\n");

  fprintf(out,"\n");

  while(!quit) {
    i = 0;
    do {
      c = fgetc(in);
      str[i++] = c;
    } while ((c!=10)&&(!feof(in)));
    i--;
    str[i] = 0;

    if(feof(in))
      quit = 1;

    int no = 0;

    if(strstr(str,"psect")) {
      if(verbose)
        printf("Removing line (psect)\n"); no=1;
      }
    if(strstr(str,"global")) {
      if(verbose)
        printf("Removing line (global)\n"); no=1;
      }
    if(strstr(str,"signat")) {
      if(verbose)
        printf("Removing line (signat)\n"); no=1;
      }

    if(!no) {
      if(strstr(str,"defs")) {
        char *s = strstr(str,"defs");
        int c;
        sscanf(s+4,"%d",&c);
        if(verbose)
          printf("defs %d-> .db %d\n",c,c);
        for(int i = 0; i < c; i++) {
          if ((i%25)==0)
            fprintf(out,"\n.db 0");
          else
            fprintf(out,", 0");
          }
        strcpy(str,"\n");
        }
      if((str[0] == '#')&&(str[1] == ' ')) {
        if(verbose)
          printf("'#'-> ';'\n");
        str[0] = ';';
        }
      if(strstr(str,"defb")) {
        char * s = strstr(str,"defb");
        if(verbose)
          printf("defb -> .db\n");
        s[0] = '.';
        s[1] = 'd';
        s[2] = 'b';
        s[3] = ' ';
        }
      if(strstr(str,"equ")) {
        char * s = strstr(str,"equ");
        if(verbose)
          printf("equ -> =\n");
        s[0] = ' ';
        s[1] = '=';
        s[2] = ' ';
        }
  // SLL not supported by tasm, replace with sla (should work.. grin.)
      if(strstr(str,"sll")) {
        char * s = strstr(str,"sll");
        if(verbose)
          printf("sll -> sla\n");
        s[0] = 's';
        s[1] = 'l';
        s[2] = 'a';
        }
      if(strstr(str,"defw")) {
        char * s = strstr(str,"defw");
        if(verbose)
          printf("defb -> .dw\n");
        s[0] = '.';
        s[1] = 'd';
        s[2] = 'w';
        s[3] = ' ';
        }
      if(strstr(str,"end")) {
        strcpy(str,"");
        }
      }

    if(!no) {
      fprintf(out,str);
      fprintf(out,"\n");
      }
    }
  fprintf(out,"\n.end\n\n");
  fclose(in);
  fclose(out);
  return 0;
}

/* Do usgard relocation.. finds all labels and adds an & in front of
 * used labels.. if needed. */
int do_relocation(char* inn, char* outn) {
  FILE *in,*out;
  char str[1024];
  char str2[1024];
  char str3[1024];

  int reloc_entries=0;

  char c;
  int i;

  if((in = fopen(inn,"rt"))==NULL) {
    printf("Couldn't open file (%s)\n",inn);
    return 1;
    }

  if((out = fopen(outn,"wt"))==NULL) {
    printf("Couldn't open file (%s)\n",outn);
    return 1;
    }
  int quit=0;

  // Scan input file for labels
  while(!quit) {
    i = 0;
    do {
      c = fgetc(in);
      str[i++] = c;
    } while ((c!=10)&&(!feof(in)));
    i--;
    str[i] = 0;
    if(feof(in))
      quit = 1;

    sscanf(str,"%s",&str2);
    if((str2[strlen(str2)-1]==':')&&(str2[0]!=';')) {
      str2[strlen(str2)-1] = 0;
      strcpy(reloc_names[reloc_entries++],str2);
      if(reloc_entries==1600) {
        printf("Error: Too many labels!\n");
        return 1;
        }
      if(verbose)
        printf("Added label:%s\n",reloc_names[reloc_entries-1]);
      }
    }

  rewind(in);
  // Add a '&' before all label uses..
  quit = 0;
  while(!quit) {
    i = 0;
    do {
      c = fgetc(in);
      str[i++] = c;
    } while ((c!=10)&&(!feof(in)));
    i--;
    str[i] = 0;
    if(feof(in))
      quit = 1;
    strcpy(str3,str);

    for(i = 0; i < reloc_entries; i++) {
      char * s = strstr(str,reloc_names[i]);
      if(s&&(s[strlen(reloc_names[i])]!=':')&&(!isalnum(s[-1]))&&(s[-1]!='_')
        &&(!isalnum(s[strlen(reloc_names[i])]))&&(s[strlen(reloc_names[i])]!='_')) {
        if(verbose)
          printf("%s in \"%s\"",reloc_names[i],str);
        sscanf(str,"%s",&str2);
        if((stricmp(str2,"jr")==0)||(stricmp(str2,"djnz")==0)) {
          if(verbose)
            printf(".. is relative, skipping\n");
          }
        else {
          c = s[0];
          s[0] = 0;
          sprintf(str3,"%s&",str);
          s[0] = c;
          strcat(str3,s);
          if(verbose)
            printf(" -> \"%s\"\n",str3);
          }
        }
      }
    fprintf(out,str3);
    fprintf(out,"\n");
    }

  fclose(in);
  fclose(out);
  return 0;
}

/* Does simple optimization: changes all jp's to jr's when possible.
 * Not very smart code, it might make a few errors now and then. */
int do_optimization(char* inn, char* outn) {
  FILE *in,*out;
  char str[1024];
  char str2[1024];
  char str3[1024];

  int reloc_entries=0;

  char c;
  int i;
  int lines = 0;
  if((in = fopen(inn,"rt"))==NULL) {
    printf("Couldn't open file (%s)\n",inn);
    return 1;
    }
  if((out = fopen(outn,"wt"))==NULL) {
    printf("Couldn't open file (%s)\n",outn);
    }
  int quit=0;

  // Scan input file for labels
  while(!quit) {
    i = 0;
    do {
      c = fgetc(in);
      str[i++] = c;
    } while ((c!=10)&&(!feof(in)));
    i--;
    str[i] = 0;
    if(feof(in))
      quit = 1;
    lines++;

    sscanf(str,"%s",&str2);
    if((str2[strlen(str2)-1]==':')&&(str2[0]!=';')) {
      str2[strlen(str2)-1] = 0;
      strcpy(reloc_names[reloc_entries],str2);
      reloc_lines[reloc_entries++] = lines;
      if(reloc_entries==1600) {
        printf("Error:Too many labels!\n");
        return 1;
        }
      if(verbose)
        printf("Added label:%s\n",reloc_names[reloc_entries-1]);
      }
    }

  rewind(in);
  // Add a '&' before all label uses..
  quit = 0;
  lines = 0;
  while(!quit) {
    i = 0;
    do {
      c = fgetc(in);
      str[i++] = c;
    } while ((c!=10)&&(!feof(in)));
    i--;
    str[i] = 0;
    if(feof(in))
      quit = 1;
    lines++;
    strcpy(str3,str);

    if(strstr(str,"jp")) {
      if((!isalnum(*(strstr(str,"jp")-1)))&&(!isalnum(*(strstr(str,"jp")+2))))
        if(verbose)
          printf("jp instruction found in line %d\n",lines);
        for(i = 0; i < reloc_entries; i++) {
          char * s = strstr(str,reloc_names[i]);
          if(s&&(s[strlen(reloc_names[i])]!=':')&&(!isalnum(s[-1]))&&(s[-1]!='_')
            &&(!isalnum(s[strlen(reloc_names[i])]))&&(s[strlen(reloc_names[i])]!='_')
            ) {
            if(strchr(str3,',')!=NULL) {
              if((strstr(str3,"c,")!=NULL)||(strstr(str3,"z,")!=NULL))
                if(abs(lines-reloc_lines[i])<40) {
                  if(verbose)
                    printf("-> Converting to jr\n");
                  s = strstr(str3,"jp");
                  s[1] = 'r';
                  }
              }
            else
              if(abs(lines-reloc_lines[i])<40) {
                if(verbose)
                  printf("-> Converting to jr\n");
                s = strstr(str3,"jp");
                s[1] = 'r';
                }
          }
        }
      }
    fprintf(out,str3);
    fprintf(out,"\n");
  }

  fclose(in);
  fclose(out);
  return 0;
}

int main() {
  char title[256];
  printf("\nCONVERT v1.01 (Hitech .AS-file -> TASM format) - Dape/Istar 1997\n");
  if(_argc<3) {
    printf("Usage: CONVERT filein.as fileout.asm [program description]\n");
    }
  else {
    if(_argc==3) {
      strcpy(title,"Untitled C-program ?");
      }
    else {
      strcpy(title,"");
      for(int i = 3; i < _argc; i++) {
        strcat(title,_argv[i]);
        strcat(title," ");
        }
      }
    if(convert_low_level(_argv[1],"convert.$00",title)==0)
      if(do_optimization("convert.$00","convert.$01")==0)
        if(do_relocation("convert.$01",_argv[2])==0) {
          printf("Success.\n");
          return 0;
          }
    }
  return 1;
}
