/* GAIN v1.0 (Global Auto-INcluder)
 * Dape/Istar 1997 (mkivela@norssi.oulu.fi)
 */

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dos.h>

#define MAX_BLOCKS 1600
#define MAX_BLOCK_NAME 32

char far block_names[MAX_BLOCKS][MAX_BLOCK_NAME] = { 0 };
char block_used[MAX_BLOCKS];
int block_count;
int verbose=0;

/* Find all tokens (from the library file) to search for in the input file */
int search(char * inn) {
  FILE *in;
  char str[256];
  char str2[32];

  if((in=fopen(inn,"rt"))==NULL) {
    printf("Error opening file:%s\n",inn);
    return -1;
    }

  block_count = 0;

  do {
    if(fgets(str,256,in)!=NULL) {

      if(str[0]=='%') {
        char * s=str+1;

        /* Get all tokens */
        while (sscanf(s,"%32s",str2)==1) {
          int v = 0;
          for(int i = 0; i < block_count; i++)
            if(strcmp(block_names[i],str2)==0)
              v++;
          if(v==0) {
            if(verbose)
              printf("New: %s\n",str2);
            strcpy(block_names[block_count],str2);
            block_used[block_count++] = 0;
            }
          s+=strlen(str2)+1;
        }
        }
      }
  } while(!feof(in));

  fclose(in);
  return 0;
}

/* Find all tokens which appear in the input file */
int find(char * inn) {
  FILE *in;
  char str[256];

  if((in=fopen(inn,"rt"))==NULL) {
    printf("Error opening file:%s\n",inn);
    return -1;
    }

  do {
    if(fgets(str,256,in)!=NULL) {
      for(int i = 0; i < block_count; i++) {
        char * s = strstr(str,block_names[i]);
        if(s!=NULL) {
          if((!isalpha(s[-1]))&&(!s[-1]!='_')) {
            s+=strlen(block_names[i]);
            if((!isalnum(s[0]))&&(!s[0]!='_')) {
              if(verbose)
                printf("Found: %s\n",block_names[i]);
              block_used[i] = 1;
              }
            }
          }
        }
      }
  } while(!feof(in));

  fclose(in);
  return 0;
}

/* Write the required blocks in the library file to the output file */
int write_req(char *inn, char *outn) {
  FILE * in, * out;
  char str[256];
  char str2[32];
  int write_mode = 0;

  if((out=fopen(outn,"wt"))==NULL) {
    printf("Error opening file:%s\n",outn);
    return -1;
    }

  if((in=fopen(inn,"rt"))==NULL) {
    printf("Error opening file:%s\n",inn);
    return -1;
    }

  do {
    if(fgets(str,256,in)!=NULL)
      {

      if(str[0]=='%') {
        char * s=str+1;
        write_mode = 0;

        /* Try all tokens */
        while ((sscanf(s,"%32s",str2)==1)&&(!write_mode)) {
          for(int i = 0; i < block_count; i++)
            if(strcmp(block_names[i],str2)==0)
              if(block_used[i])
                write_mode = 1;
          s+=strlen(str2)+1;
        }
        if(write_mode)
          strcpy(str,"");
        }
      if(write_mode)
        fputs(str,out);
      }
  } while(!feof(in));

  fputs("\n",out);

  fclose(in);
  fclose(out);
  return 0;
}

/* Append the original input file to the output file */
int append(char *inn, char *outn) {
  FILE * in, * out;
  char str[256];

  if((out=fopen(outn,"at"))==NULL) {
    printf("Error opening file:%s\n",outn);
    return -1;
    }
  fseek(out,0,SEEK_END);

  if((in=fopen(inn,"rt"))==NULL) {
    printf("Error opening file:%s\n",inn);
    return -1;
    }

  while(fgets(str,256,in))
    fputs(str,out);

  fputs("\n",out);

  fclose(in);
  fclose(out);
  return 0;
}

int main() {
  printf("\nGAIN v1.0 (Global Auto-INcluder) - Dape/Istar 1997\n");
  if(_argc<4) {
    printf("\nUsage: GAIN <library> <file.in> <file.out>\n\n");
    printf("\t<library> - function library file in GAIN format\n");
    printf("\t<file.in>    - input file name\n");
    printf("\t<file.out>   - output file name\n");
    }
  else
    if(search(_argv[1])==0)
      if(find(_argv[2])==0)
        if(write_req(_argv[1],_argv[3])==0)
         if(append(_argv[2],_argv[3])==0) {
           printf("Success.\n");
           return 0;
           }
  return 1;
}
